// JChatClient.cpp : implementation file
//  

#include "stdafx.h"
#include "JChatClient.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// JChatClient

IMPLEMENT_DYNCREATE(JChatClient, CWinThread)

JChatClient::JChatClient()
{
	bStart = false;
	bLoop = true;
}

JChatClient::~JChatClient()
{
}

BOOL JChatClient::InitInstance()
{
	// TODO:  perform and per-thread initialization here
	return TRUE;
}

int JChatClient::ExitInstance()
{
	// TODO:  perform any per-thread cleanup here
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(JChatClient, CWinThread)
	//{{AFX_MSG_MAP(JChatClient)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()






// Ŭ̾Ʈ   α׷

void JChatClient::start( LPVOID aParam, LPVOID bParam ) 
{
	clntSock = *( (SOCKET *)aParam );
	bStart = true;

	parent = (JChatDialog *)bParam;
}

void JChatClient::stop()
{
	bLoop = false;
	bStart = false;
}

int JChatClient::Run()
{
	char buffer[MAXDATA];  // MAXDATA defined in JChatProtocol.h
	CString data;

	while ( bLoop ) {
		while ( bStart ) {
			int rec = recv( clntSock, buffer, MAXDATA, 0 );

			// rec == 0     Ŭ̾Ʈ    .
			if ( rec == 0 ) {
				bStart = false;
				bLoop = false;
				MessageBox( this->m_pMainWnd->m_hWnd, _T( " ϴ." ), data.operator LPCTSTR(), MB_OK );
				AfxEndThread( 0, true );
			}

			if ( rec != SOCKET_ERROR ) {
				data = buffer;
	
				data.TrimLeft();
				data.TrimRight();
	
				if ( data.Find( _T( "$LOGINXX" ) ) == 0 ) {
					ProcessLogin();
					continue;
				}

				if ( data.Find( _T( "$RELOGIN" ) ) == 0 ) {
					ProcessRelogin();
					continue;
				}

				if ( data.Find( _T( "$ACCEPTL" ) ) == 0 ) {
					ProcessAcceptLogin( data );
					continue;
				}

				if ( data.Find( _T( "$CHANNEL" ) ) == 0 ) {
					ProcessChannel( data );
					continue;
				}

				if ( data.Find( _T( "$ACCEPTC" ) ) == 0 ) {
					ProcessAcceptChannel( data );
					continue;
				}

				if ( data.Find( _T( "$DIALOGX" ) ) == 0 ) {
					ProcessDialog( data );
					continue;
				}

				if ( data.Find( _T( "$RECHANN" ) ) == 0 ) {
					ProcessRemakeChannel();
					continue;
				}

				if ( data.Find( _T( "$REICHAN" ) ) == 0 ) {
					ProcessReinChannel();
					continue;
				}

				if ( data.Find( _T( "$ICHANNE" ) ) == 0 ) {
					ProcessInChannel( data );
					continue;
				}

				if ( data.Find( _T( "$OCHANNE" ) ) == 0 ) {
					ProcessOutChannel( data );
					continue;
				}

				if ( data.Find( _T( "$ACCEPIC" ) ) == 0 ) {
					ProcessAcceptInChannel( data );
					continue;
				}

				if ( data.Find( _T( "$USERINC" ) ) == 0 ) {
					ProcessUsers( data );
					continue;
				}

				if ( data.Find( _T( "$DCHANNE" ) ) == 0 ) {
					ProcessDelChannel( data );
					continue;
				}

				if ( data.Find( _T( "$SILENTW" ) ) == 0 ) {
					ProcessSilentWord( data );
					continue;
				}

				if ( data.Find( _T( "$NOOPXXX" ) ) == 0 ) {
					ProcessNoopSignal();
				}
			}
			Sleep( 0 );
		}
		Sleep( 0 );
	}

	return CWinThread::Run();
}


void JChatClient::ProcessLogin()
{
	parent->setState_connect();

	parent->listConv.AddText( "  Ǿϴ." );
	parent->listConv.AddText( "äÿ  ̵ Է ֽʽÿ." );
	parent->listConv.AddText( "̵ : " );

	parent->editProcess = BLOGIN;
	parent->strConv.SetFocus();
}

void JChatClient::ProcessRelogin()
{
	parent->listConv.AddText( "Է ̵ ̹ ٸ ڿ ؼ" );
	parent->listConv.AddText( "Ǿ  ֽϴ." );
	parent->listConv.AddText( "ٸ ̵ Էϼ." );
	parent->listConv.AddText( "̵ : " );

	parent->editProcess = BLOGIN;
}

void JChatClient::ProcessAcceptLogin( CString data )
{
	CString head = data.Mid( COMMANDLENGTH, AFTERLENGTH );
	CString real = data.Mid( HEADERINFO, atoi( (const char *)( head.operator LPCTSTR() ) ) );

	parent->listConv.AddText( "̵ ȿմϴ." );
	parent->listConv.AddText( "ſ ä ǽʽÿ." );

	parent->SetUserID( real );
}

void JChatClient::ProcessChannel( CString data )
{
	CString head = data.Mid( COMMANDLENGTH, AFTERLENGTH );
	CString real = data.Mid( HEADERINFO, atoi( (const char *)( head.operator LPCTSTR() ) ) );
	CString channel, token = "";
	int nUser;
	int index, endindex;

	bool bLoop = true;

	CnvRoom aRoom;

	// test$1$16  => ȭ ̸ test ̰ ȣ ,   16
	// ȭ̸$ȭȣ$ȭڼ$ȭ̸$ȭȣ$ȭڼ ...  ؼسϴ.
	while ( bLoop ) {
		index = real.Find( _T( "$" ), 0 );
		channel = real.Mid( 0, index );

		if ( ( index = real.Find( _T( "$" ), channel.GetLength() + 4 ) ) == -1 ) {
			bLoop = false;
			endindex = real.GetLength();
		} else {
			endindex = index + 1;
		}

		token = real.Mid( channel.GetLength() + 1, 1 );
		aRoom.bCode = ( token == "1" ) ? true : false;

		token = real.Mid( channel.GetLength() + 3, endindex - channel.GetLength() - 3 );
		nUser = atoi( (const char *)( token.operator LPCTSTR() ) );

		if ( bLoop ) real = real.Mid( endindex, atoi( (const char *)( head.operator LPCTSTR() ) ) - index );

		aRoom.numUser = nUser;
		aRoom.strName = channel;
		parent->AddSvRoom( aRoom );
	}
}

void JChatClient::ProcessAcceptChannel( CString data )
{
	CString head = data.Mid( COMMANDLENGTH, AFTERLENGTH );
	CString real = data.Mid( HEADERINFO, atoi( (const char *)( head.operator LPCTSTR() ) ) );

	parent->setState_convin();

	parent->AddMeRoom( real );
	parent->listConv.AddText( "ȭ ϴ." );
}

void JChatClient::ProcessDialog( CString data )
{
	CString head = data.Mid( COMMANDLENGTH, AFTERLENGTH );
	CString real = data.Mid( HEADERINFO, atoi( (const char *)( head.operator LPCTSTR() ) ) );

	parent->listConv.AddText( real );
}

void JChatClient::ProcessRemakeChannel()
{
	parent->listConv.AddText( "̹  ̸ ȭ ֽϴ." );
	parent->listConv.AddText( "ٽ Է ֽʽÿ." );
}

void JChatClient::ProcessReinChannel()
{
	parent->listConv.AddText( "  ȭ Ǿ  ʰų" );
	parent->listConv.AddText( "йȣ Ʋ Է߽ϴ." );
	parent->listConv.AddText( "ٸ ȭ Ͻʽÿ." );
}

void JChatClient::ProcessInChannel( CString data )
{
	CString head = data.Mid( COMMANDLENGTH, AFTERLENGTH );
	CString real = data.Mid( HEADERINFO, atoi( (const char *)( head.operator LPCTSTR() ) ) );

	CString info;
	info.Format( _T( "[%s] Բ ϼ̽ϴ." ), real );

	parent->listUser.AddString( real );
	parent->listConv.AddText( info );
}

void JChatClient::ProcessOutChannel( CString data )
{
	CString head = data.Mid( COMMANDLENGTH, AFTERLENGTH );
	CString real = data.Mid( HEADERINFO, atoi( (const char *)( head.operator LPCTSTR() ) ) );

	CString info;
	info.Format( _T( "[%s] Բ ϼ̽ϴ." ), real );

	int index = parent->listUser.FindString( 0, real );
	if ( index == LB_ERR ) return;
	else parent->listUser.DeleteString( index );

	parent->listConv.AddText( info );
}

// ACCEPIC ȣĿ ش ȭ   ProcessUsers  ɴϴ.
void JChatClient::ProcessAcceptInChannel( CString data )
{
	CString head = data.Mid( COMMANDLENGTH, AFTERLENGTH );
	CString real = data.Mid( HEADERINFO, atoi( (const char *)( head.operator LPCTSTR() ) ) );

	parent->setState_convin();

	parent->SetCurChannel( real );
	parent->listConv.AddText( "ȭ濡 մϴ." );
}

void JChatClient::ProcessUsers( CString data )
{
	CString chUser;
	CString head = data.Mid( COMMANDLENGTH, AFTERLENGTH );
	CString real = data.Mid( HEADERINFO, atoi( (const char *)( head.operator LPCTSTR() ) ) );
	bool bLoop = true;
	int index;

	// ش ȭ ڸ listUser  ߰մϴ.
	while ( bLoop ) {
		index = real.Find( _T( "$" ), 0 );
		if ( index == -1 ) {
			index = real.GetLength() - 1;
			bLoop = false;
		}
		chUser = real.Mid( 0, index );

		parent->listUser.AddString( chUser );
		if ( bLoop ) real = real.Mid( index + 1, real.GetLength() - index - 1 );
	}		
}

void JChatClient::ProcessDelChannel( CString data )
{
	CString head = data.Mid( COMMANDLENGTH, AFTERLENGTH );
	CString real = data.Mid( HEADERINFO, atoi( (const char *)( head.operator LPCTSTR() ) ) );
	
	parent->DeleteSvRoom( real );
}

void JChatClient::ProcessSilentWord( CString data )
{
	CString head = data.Mid( COMMANDLENGTH, AFTERLENGTH );
	CString real = data.Mid( HEADERINFO, atoi( (const char *)( head.operator LPCTSTR() ) ) );

	parent->listConv.AddText( real );
}

void JChatClient::ProcessNoopSignal()
{
	char command[] = "$NOOPXXX";

	send( clntSock, command, strlen( command ), 0 );
}
