// JEnterRoomDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LanChatClientCOM.h"

#include "JEnterRoomDlg.h"
#include "JInputStringDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// JEnterRoomDlg dialog


JEnterRoomDlg::JEnterRoomDlg(CWnd* pParent /*=NULL*/)
	: CDialog(JEnterRoomDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(JEnterRoomDlg)
	strName = _T("");
	//}}AFX_DATA_INIT
}


void JEnterRoomDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(JEnterRoomDlg)
	DDX_Control(pDX, IDOK, btnOk);
	DDX_Control(pDX, IDC_LISTROOM, listRoom);
	DDX_Text(pDX, IDC_EDITCONVNAME, strName);
	DDV_MaxChars(pDX, strName, 49);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(JEnterRoomDlg, CDialog)
	//{{AFX_MSG_MAP(JEnterRoomDlg)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LISTROOM, OnItemchangedListroom)
	ON_NOTIFY(NM_DBLCLK, IDC_LISTROOM, OnDblclkListroom)
	ON_EN_CHANGE(IDC_EDITCONVNAME, OnChangeEditconvname)
	ON_BN_CLICKED(ID_LISTUPDATE, OnListupdate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// JEnterRoomDlg message handlers

// Ʈ Ʈ  ٲ ȭ ̸  ڽ ø ok btn ȰȭŲ.
void JEnterRoomDlg::OnItemchangedListroom(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	int index;
    CHAR data[256];

	btnOk.EnableWindow( true );
	index = pNMListView->iItem;
	listRoom.GetItemText( index, 0, data, 256 );

	strName = data;
	UpdateData( false );

	*pResult = 0;
}

// Ok btn Ŭ ȿ ´.
void JEnterRoomDlg::OnDblclkListroom(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	if ( strName.GetLength( ) ) OnOK( );
	*pResult = 0;
}

// Editor ڽ ȭ̸ ö OKư ȰȭŲ.
void JEnterRoomDlg::OnChangeEditconvname() 
{
	// TODO: Add your control notification handler code here
	UpdateData( true );
	if ( strName.GetLength( ) ) btnOk.EnableWindow( true );
}

void JEnterRoomDlg::OnOK() 
{
	// TODO: Add extra validation here
	int retVal;
	strCode = "none";

	UpdateData( true );

	for ( int i = 0; i < Room->GetSize( ); i ++ ) {
		if ( !strcmp( (const char *)( strName.operator LPCTSTR() ), (const char *)( Room->GetAt( i ).strName.operator LPCTSTR() ) ) ) 
			break;
	}

	if ( i >= Room->GetSize( ) ) {
		AfxMessageBox( _T( "ȭ ̸ ߸ Ǿϴ." ) );
		return;
	}

	if ( Room->GetAt( i ).bCode ) {
		JInputStringDlg dlg;
		retVal = dlg.DoModal();
		if ( retVal != IDOK ) return;
		else {
			strCode = dlg.strCodeName;
		}
	}

	CDialog::OnOK();
}

// Ʈ ڽ ÷ Ѵ
BOOL JEnterRoomDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	LV_COLUMN col;
	CnvRoom Adata;

	col.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	col.fmt = LVCFMT_CENTER;
	col.pszText = _T( "ȭ ̸" );
	col.iSubItem = 0;
	col.cx = 400;
	col.cchTextMax = 500;
	listRoom.InsertColumn( 0, &col );

	col.pszText = _T( " " );
	col.iSubItem = 1;
	col.cx = 100;
	col.cchTextMax = 150;
	listRoom.InsertColumn( 1, &col );

	col.pszText = _T( "ȣ" );
	col.iSubItem = 2;
	col.cx = 100;
	col.cchTextMax = 150;
	listRoom.InsertColumn( 2, &col );
	
	int i;
	LV_ITEM item;
	CHAR tmp[256];

	item.mask = LVIF_TEXT;

	for ( i = 0; i < Room->GetSize( ); i ++ ) {
		Adata = Room->GetAt( i );
		item.iItem = i;
		item.iSubItem = 0;
		item.pszText = (char *)Adata.strName.operator LPCTSTR();
		listRoom.InsertItem( &item );

		item.iSubItem = 1;
		sprintf( tmp, "%d", Adata.numUser );
		item.pszText = tmp;
		listRoom.SetItem( &item );

		item.iSubItem = 2;
		sprintf( tmp, "%s", Adata.bCode ? "Y" : "N" );
		item.pszText = tmp;
		listRoom.SetItem( &item );
	} 

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

// ȭ Ȳ Ʈ ڽ ƴ´.
void JEnterRoomDlg :: Init( const CArray<CnvRoom, CnvRoom> *arrRoom )
{
	Room = arrRoom;
}

void JEnterRoomDlg::OnListupdate() 
{
	strName = "Update Channel List";
	OnCancel();
}
