// JServerInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LanChatClientCOM.h"
#include "JServerInfoDlg.h"
#include <afxsock.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// JServerInfoDlg dialog


JServerInfoDlg::JServerInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(JServerInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(JServerInfoDlg)
	//}}AFX_DATA_INIT
}


void JServerInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(JServerInfoDlg)
	DDX_Control(pDX, IDC_CBDOMAIN, svDomain);
	DDX_Control(pDX, IDC_CBPORT, svPort);
	DDX_Control(pDX, IDC_SERVERIP, svIP);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(JServerInfoDlg, CDialog)
	//{{AFX_MSG_MAP(JServerInfoDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// JServerInfoDlg message handlers

BOOL JServerInfoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	CString str, str2;
	PHOSTENT pHostEntry;
	IN_ADDR inAddr;

	// --------------- ⺻  Ӱ Ʈ Ѵ. -------------------- //
	svDomain.SetCurSel( DEFAULT_DOMAINNAME );
	svPort.SetCurSel( DEFAULT_LANPORT );

	// ----------------  Ӱ Ʈ, IP ּҸ hinfo ü ä. -- //
	int index = svDomain.GetCurSel( );
	svDomain.GetLBText( index, str );
	if ( ( pHostEntry = gethostbyname( (const char *)( str.operator LPCTSTR() ) ) ) != NULL ) {
		memcpy( &inAddr, pHostEntry->h_addr, 4 );
		svIP.SetAddress( inAddr.S_un.S_un_b.s_b1, inAddr.S_un.S_un_b.s_b2, 
						   inAddr.S_un.S_un_b.s_b3, inAddr.S_un.S_un_b.s_b4 );
		str2.Format( _T( "%d.%d.%d.%d" ), inAddr.S_un.S_un_b.s_b1, inAddr.S_un.S_un_b.s_b2,
										inAddr.S_un.S_un_b.s_b3, inAddr.S_un.S_un_b.s_b4 );
	} else {
		svIP.SetAddress( 0, 0, 0, 0 );
		str2 = "0.0.0.0";
	}

	strcpy( info.Domain, (const char *)( str.operator LPCTSTR() ) );
	strcpy( info.IP, (const char *)( str2.operator LPCTSTR() ) );

	index = svPort.GetCurSel( );
	svPort.GetLBText( index, str );
	info.Port = ::atol( (const char *)( str.operator LPCTSTR() ) );
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

JServerInfo JServerInfoDlg :: Get( void ) const
{
	return info;
}

void JServerInfoDlg::OnOK() 
{
	// TODO: Add extra validation here
	CString str;
	int index;

// Port Setting
// ---------  Combo  Edit ڽ ߴٸ AddString Ұ ϰ info ִ´.
	svPort.GetWindowText( str );
	index = svPort.FindString( 0, str );
	if ( index == CB_ERR ) {
		index = ::atoi( (const char *)( str.operator LPCTSTR() ) );
		if ( index != 0 ) {
			svPort.AddString( str );
			index = svPort.FindString( 0, str );
		} else index = DEFAULT_LANPORT;
	}
	svPort.SetCurSel( index );
	svPort.GetLBText( index, str );
	info.Port = ::atol( (const char *)( str.operator LPCTSTR() ) );

// Domain Setting
// --------  Combo  Edit ڽ ߴٸ AddString   ϰ info ִ´.
	svDomain.GetWindowText( str );
	index = svDomain.FindString( 0, str );
	if ( index == CB_ERR ) {
		svDomain.AddString( str );
		index = svDomain.FindString( 0, str );
	}

	svDomain.SetCurSel( index );
	svDomain.GetLBText( index, str );
	strcpy( info.Domain, (const char *)( str.operator LPCTSTR() ) );

// IP Address Setting
// ---------- Edit Ǿ  IP Address  ٽ ؼ info  ִ´.
	unsigned char a, b, c, d;
	svIP.GetAddress( a, b, c, d );
	str.Format( _T( "%d.%d.%d.%d" ), a, b, c, d );
	strcpy( info.IP, (const char *)( str.operator LPCTSTR() ) );

	CDialog::OnOK();
}

