#if !defined(AFX_JCHATCLIENT_H__24B234F9_5097_11D3_B93D_204C4F4F5020__INCLUDED_)
#define AFX_JCHATCLIENT_H__24B234F9_5097_11D3_B93D_204C4F4F5020__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "JChatDialog.h"
#include ".\ChatProtocol\JChatProtocol.h"

// JChatClient.h : header file
//

class JChatDialog;

/////////////////////////////////////////////////////////////////////////////
// JChatClient thread

class JChatClient : public CWinThread
{
	DECLARE_DYNCREATE(JChatClient)
protected:
	JChatClient();           // protected constructor used by dynamic creation

// Attributes
public:

// Operations
public:
	SOCKET clntSock;
	bool bStart;
	bool bLoop;

	void start( LPVOID aParam, LPVOID bParam );
	void stop();
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(JChatClient)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	virtual int Run();
	//}}AFX_VIRTUAL

// Implementation
protected:
	JChatDialog *parent;

	virtual ~JChatClient();

	void ProcessLogin();
	void ProcessRelogin();
	void ProcessAcceptLogin( CString data );
	void ProcessChannel( CString data );
	void ProcessAcceptChannel( CString data );
	void ProcessDialog( CString data );
	void ProcessRemakeChannel();
	void ProcessReinChannel();
	void ProcessInChannel( CString data );
	void ProcessOutChannel( CString data );
	void ProcessAcceptInChannel( CString data );
	void ProcessUsers( CString data );
	void ProcessDelChannel( CString data );
	void ProcessSilentWord( CString data );

	void ProcessNoopSignal();

	// Generated message map functions
	//{{AFX_MSG(JChatClient)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JCHATCLIENT_H__24B234F9_5097_11D3_B93D_204C4F4F5020__INCLUDED_)
