// JMakeRoomDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LanChatClientCOM.h"
#include "JMakeRoomDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// JMakeRoomDlg dialog


JMakeRoomDlg::JMakeRoomDlg(CWnd* pParent /*=NULL*/)
	: CDialog(JMakeRoomDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(JMakeRoomDlg)
	strName = _T("");
	strCode = _T("");
	chCode = FALSE;
	//}}AFX_DATA_INIT
	chCode = false;
}


void JMakeRoomDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(JMakeRoomDlg)
	DDX_Control(pDX, IDOK, OkBtn);
	DDX_Text(pDX, IDC_ROOMNAME, strName);
	DDV_MaxChars(pDX, strName, 50);
	DDX_Text(pDX, IDC_CONVCODE, strCode);
	DDV_MaxChars(pDX, strCode, 6);
	DDX_Check(pDX, IDC_USECODE, chCode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(JMakeRoomDlg, CDialog)
	//{{AFX_MSG_MAP(JMakeRoomDlg)
	ON_EN_CHANGE(IDC_ROOMNAME, OnChangeRoomname)
	ON_BN_CLICKED(IDC_USECODE, OnUsecode)
	ON_EN_CHANGE(IDC_CONVCODE, OnChangeConvcode)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// JMakeRoomDlg message handlers

void JMakeRoomDlg::OnChangeRoomname() 
{
	// TODO: Add your control notification handler code here
	UpdateData( true );
	if ( chCode ) {
		if ( strName.GetLength() && strCode.GetLength() ) OkBtn.EnableWindow();
	} else {
		if ( strName.GetLength() ) OkBtn.EnableWindow();
	}
}

void JMakeRoomDlg::OnChangeConvcode() 
{
	// TODO: Add your control notification handler code here
	UpdateData( true );
	if ( chCode ) 
		if ( strCode.GetLength() && strName.GetLength() ) OkBtn.EnableWindow();
}

void JMakeRoomDlg::OnUsecode() 
{
	// TODO: Add your control notification handler code here
	chCode = 1-chCode;

	GetDlgItem( IDC_CONVCODE )->EnableWindow( chCode );
}

BOOL JMakeRoomDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	GetDlgItem( IDC_ROOMNAME )->SetFocus();

	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
