#if !defined(AFX_LANCHATCLIENTCOMCTL_H__7753AD14_643F_11D3_B975_204C4F4F5020__INCLUDED_)
#define AFX_LANCHATCLIENTCOMCTL_H__7753AD14_643F_11D3_B975_204C4F4F5020__INCLUDED_

#include <afxwin.h>
#include "JChatDialog.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// LanChatClientCOMCtl.h : Declaration of the CLanChatClientCOMCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CLanChatClientCOMCtrl : See LanChatClientCOMCtl.cpp for implementation.

#define WM_STARTMESSAGE ( WM_USER + 100 )

class CLanChatClientCOMCtrl : public COleControl
{
	DECLARE_DYNCREATE(CLanChatClientCOMCtrl)

// Constructor
public:
	JChatDialog chatWindow;
	CButton btnStart;
	CLanChatClientCOMCtrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLanChatClientCOMCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

// Implementation
protected:
	~CLanChatClientCOMCtrl();

	DECLARE_OLECREATE_EX(CLanChatClientCOMCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CLanChatClientCOMCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CLanChatClientCOMCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CLanChatClientCOMCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CLanChatClientCOMCtrl)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg long OnStartChat( WPARAM wParam, LPARAM lParam );
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

protected:
// Dispatch maps
	//{{AFX_DISPATCH(CLanChatClientCOMCtrl)
	BOOL m_btnStartChat;
	afx_msg void OnBtnStartChatChanged();

public:
	afx_msg void StartChat();
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

protected:
// Event maps
	//{{AFX_EVENT(CLanChatClientCOMCtrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CLanChatClientCOMCtrl)
	dispidBtnStartChat = 2L,
	dispidStartChat = 1L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LANCHATCLIENTCOMCTL_H__7753AD14_643F_11D3_B975_204C4F4F5020__INCLUDED)
